/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/* Header files */
#ifdef VX
#include <taskLib.h>
#endif
#include "js-runtime.h"
#include "js-runtimeexception.h"
#include "js-exceptionhandler.h"
#include "js-zone.h"
#if 0
#include "ewb-sys.h"
#include "ewb-sys-if.h"
#else
#define EWB_ERROR_JS_MEMORY 4
extern "C" {
    extern void EwbNotifyError(const unsigned char);
}
#endif
#include "js-api.h"
#if 0
#include "ewb-dbg.h"
#include "ewb-trace.h"
#else
#include "js-dbg.h"
#include "js-trace.h"
#endif
extern int ewbPrintOn;

/* Classes */
void *JSZone::Allocator::memalign(size_t alignment, size_t size)
{
    void *ptr = runtime->localZoneHeap.memalign(alignment, size);

    if (ptr == NULL) {
        if (ewbPrintOn) {
            printf("Call GC. Because EWB Compile mem Exhaused(2). But, This is no problem.");
        }
        JSContext *cx = JSContext::getCurrentContext();

        char jsLogbuf[128];
        memset(jsLogbuf, 0, sizeof(jsLogbuf));
        sprintf(jsLogbuf, "Call GC from CompilePart(a) size:%d. 1st Log is Befor GC. 2nd is after.\n", size);
        EwbSetLog(jsLogbuf);
        JS_GCMemFreeShow(cx, 1);
        JS_GC(cx);
        JS_GCMemFreeShow(cx, 1);

        ptr = runtime->localZoneHeap.memalign(alignment, size);
        if (ptr == NULL) {
            EwbSetLog("JS Compile Memory Exhaused. Be necessary to expand JS Compile Memory\n");
#ifndef SHELL
            EwbNotifyError(EWB_ERROR_JS_MEMORY);
#endif
#if defined(SUNOS5) || defined(TARGET_OS_LINUX)
            exit(1);
#elif defined(VX)
            taskSuspend(0);
#else
            ->
#endif
        }
    }
    return ptr;
}

void *JSZone::Allocator::malloc(size_t size)
{
    void *ptr;
    ptr = runtime->localZoneHeap.malloc(size);

    if (ptr == NULL) {
        if (ewbPrintOn) {
            printf("Call GC. Because EWB Compile mem Exhaused(3). But, This is no problem.");
        }
        JSContext *cx = JSContext::getCurrentContext();

        char jsLogbuf[128];
        memset(jsLogbuf, 0, sizeof(jsLogbuf));
        sprintf(jsLogbuf, "Call GC from CompilePart(b) size:%d. 1st Log is Befor GC. 2nd is after.\n", size);
        EwbSetLog(jsLogbuf);
        JS_GCMemFreeShow(cx, 1);
        JS_GC(cx);
        JS_GCMemFreeShow(cx, 1);

        ptr = runtime->localZoneHeap.malloc(size);
        if (ptr == NULL) {
            EwbSetLog("JS Compile Memory Exhaused. Be necessary to expand JS Compile Memory\n");
#ifndef SHELL
            EwbNotifyError(EWB_ERROR_JS_MEMORY);
#endif
#if defined(SUNOS5) || defined(TARGET_OS_LINUX)
            exit(1);
#elif defined(VX)
            taskSuspend(0);
#else
            ->
#endif
        }
    }
    return ptr;
}

void JSZone::Allocator::free(void *ptr)
{
    runtime->localZoneHeap.free(ptr);

}

JSZone::Allocator::Allocator(JSRuntime * runtime)
{
    this->runtime = runtime;
}

void JSZone::PhaseListener::markAll()
{
}
void JSZone::PhaseListener::finalize(void *obj)
{
}
void JSZone::PhaseListener::stopWorld()
{
}
void JSZone::PhaseListener::resumeWorld()
{
}

#ifdef THREADS
void JSZone::MutexListener::lock()
{
}
void JSZone::MutexListener::unlock()
{
}
#endif
void JSZone::destroy(JSRuntime * runtime)
{
    this->~JSZone();
    JSRuntimeNew::destroy(runtime);
}

JSZone::JSZone(JSRuntime * runtime)
:      allocator(runtime)
{
    setMemoryAllocator(&allocator);
    setPhaseListener(&phaseListener);
#ifdef THREADS
    setMutexListener(&mutexListener);
#endif

    disabled = True;
}
